/**
 * Boilerplate code required to hook into the ADTECH rich media library.
 *
 * For API documentation, please contact canvas-help@adtech.com
 */
if(false){
	ADTECH.event('expanded');	
	ADTECH.event('contracting');
	ADTECH.event('contracted');
}
 
(function(adConfig) {
  var requiresBreakout = false;
  if (!adConfig.overrides || adConfig.overrides.displayWindowTarget != self) {
    for (var id in adConfig.assetContainers) {
      if (adConfig.assetContainers.hasOwnProperty(id)) {
        var container = adConfig.assetContainers[id];
        if (container.type != 'inlineDiv' || container.isExpandable) {
          requiresBreakout = true;
          break;
        }
      }
    }
  }

  if (adConfig.overrides && adConfig.overrides.displayWindowTarget) {
    var displayWindowTarget = adConfig.overrides.displayWindowTarget;
    displayWindowTarget = (typeof adtechIframeHashArray != 'undefined' && self != top) ?
        displayWindowTarget.parent : displayWindowTarget;
  } else {
    var calculatedTarget = null;
    var currentWindow = parent;
    while (currentWindow != undefined) {
      try {
        var targetDoc = currentWindow.document;
        if (targetDoc) {
          calculatedTarget = currentWindow;
        }
      } catch(e) {}
      currentWindow = (currentWindow == top) ? null : currentWindow.parent;
    }
    var displayWindowTarget = calculatedTarget || top;
  }

  var targetIsFriendly = false;
  try {
    var targetDoc = displayWindowTarget.document;
    if (targetDoc) {
      targetIsFriendly = true;
    }
  } catch(e) {}

  var targetWindow = (requiresBreakout && (self != top && targetIsFriendly)) ?
          displayWindowTarget : self;

  targetWindow.com = targetWindow.com || {};
  targetWindow.com.adtech = targetWindow.com.adtech || {};

  targetWindow.com.adtech.AdtechCustomAd$AD_ID$ = function() {
    // Custom code class constructor.
  };

  targetWindow.com.adtech.AdtechCustomAd$AD_ID$.prototype = {

    /**
     * Entry point methods.
     *
     * Automatically invoked by the rich media library when the library API is
     * available to use, and the Advert instance has been instantiated.
     */
	preInit: function() {
	  window.com = com || {};
	  com.adtech = targetWindow.com.adtech;
    },

    init: function(advert) {
      if (!advert.richView) {
        // The backup client can not render the rich version of the advert.
        return;
      }
      
      // A few useful things to help you get started. Please delete as necessary!
      this.advert = advert;
	  	this.utils = com.adtech.Utils_$VERSION$;
      this.globalEventBus = targetWindow.adtechAdManager_$VERSION$.globalEventBus;
      this.richMediaEvent = com.adtech.RichMediaEvent_$VERSION$;
			this.container =  this.advert.getAssetContainer('main');
			if (this.container.rendered) {
  			this.renderEventHandler();
			}else{
  			this.container.addEventListener('render', this.renderEventHandler, this);
	  	}
      /*
       * This is how you listen for your custom events.
       * ADTECH.close() is actually just an alias of ADTECH.event('close').
       */
      advert.eventBus.addEventListener('close',
          this.utils.createClosure(this, this.closeHandler));
			//this.globalEventBus.addEventListener(this.richMediaEvent.PAGE_SCROLL,this.pageScrollHandler,this);
			this.utils.registerNativeEventHandler(window,'scroll', this.utils.createClosure(this, this.pageScrollHandler));
      /*
       * Want to wait until the DOM or the page has loaded? No problem!
       */
      if (this.globalEventBus.pageLoaded) {
        this.pageLoadHandler();
      } else {
        this.globalEventBus.addEventListener(this.richMediaEvent.PAGE_LOAD,
            this.utils.createClosure(this, this.pageLoadHandler));
      }
    },

    /*********************************************************
     *
     * Create your instance methods below.
     *
     * Please remember not to add a trailing comma to you last
     * method - IE will not like that!
     *
     *********************************************************/
		renderEventHandler:function(){
			this.isExpanded = false;
			this.container.div.style.width = '100%';
			this.container.div.style.height = '100%';
			this.container.div.style.clip = 'auto';
			this.container.content.contentObject.style.height = '100%';
			this.container.content.contentObject.style.width = '100%';
			this.container.anchorDiv.style.transitionDuration = '.12s';
			this.container.anchorDiv.style.transitionDelay = '.01s';
			this.container.anchorDiv.style.transitionProperty = 'height';
			this.container.anchorDiv.style.width = '100%';
			this.lastOff = this.utils.getPageOffsets();
			//setTimeout(this.utils.createClosure(this, this.pageScrollHandler),500);
			//this.pageScrollHandler();
			
		},
    closeHandler: function() {
      /*
       * This will get invoked when the close event has been dispatched by any one
       * of your ad units.
       */
    },

    pageLoadHandler: function() {
      // The page has now loaded. Feel free to display an awesome advert.
    },
    pageScrollHandler:function(){
    	var off = this.utils.getPageOffsets();
    	var dim = this.utils.getViewportDims();
    	var pos = this.utils.calculateAbsolutePosition(this.container.anchorDiv);
    	var maxH = dim.h*.6;
    	
    	//if(pos.y+80<off.y+dim.h){
    	if(pos.y<off.y+dim.h){
    		//if(pos.y-off.y>dim.h*.5){
    			var cent = (maxH)*.5;
    			cent = this.container.anchorDiv.clientHeight*.5;
    			var scent = dim.h*.5;
    			/*if(pos.y-off.y<80){
    				this.container.anchorDiv.style.height = Math.min(maxH,Math.max(50,(maxH-(off.y-pos.y))))+'px';
    			}else{
    				this.container.anchorDiv.style.height = Math.min(maxH,Math.max(50,(maxH-(pos.y-off.y))))+'px';
    				
    			}*/
    		//}
    		var fact=0,scaleFact=.8;
    			if((pos.y-off.y)+cent>scent){
    				//var fact = ((((pos.y-off.y)+(cent))-scent)/(scent));
    				//var fact = (((pos.y+(this.container.anchorDiv.clientHeight*.5))-off.y)-scent)/scent;
    				fact = 1-Math.min(1,(((pos.y-off.y)-scent)+cent)/(scent*scaleFact));
    				////console.log('B: '+fact+' '+pos.y+' '+off.y+' Y:'+(((pos.y-off.y)-scent)+cent)+' '+(((pos.y+(this.container.anchorDiv.clientHeight*.5))-off.y)-scent)+' '+scent);
    			}else{
    				fact = Math.min(1,(((pos.y-off.y))+cent)/(scent*scaleFact));
    				////console.log('T: '+fact+' '+pos.y+' '+off.y+' Y:'+(((pos.y-off.y))+cent)+' '+(((pos.y+(this.container.anchorDiv.clientHeight*.5))-off.y)-scent)+' '+scent+' '+cent);
    			}
    			if(fact>.95){
    				fact = 1;
    				if(!this.isExpanded){
    					this.advert.eventBus.dispatchEvent('expanded');
    					this.isExpanded = true;
    				}
    				////console.log(fact);
    			}else if(this.isExpanded){
    				this.advert.eventBus.dispatchEvent('contracting');
    				this.isExpanded = false;
    			}
    			var height = Math.min(maxH,Math.max(50,(maxH*fact)));
    			if(height != this.lastHeight && height == 50){
    				this.advert.eventBus.dispatchEvent('contracted');
    			}
    			this.container.anchorDiv.style.height = height+'px';
    			this.lastHeight = height;
    	}
    }
  };

  targetWindow.adtechCallbackInstances = targetWindow.adtechCallbackInstances || [];
  var instanceIndex = targetWindow.adtechCallbackInstances.length;
  targetWindow.adtechCallbackInstances[instanceIndex] =
      new targetWindow.com.adtech.AdtechCustomAd$AD_ID$();

  targetWindow.adtechAdCallbacks = targetWindow.adtechAdCallbacks || {};
  targetWindow.adtechAdCallbacks[adConfig.adServerVars.uid] =
      targetWindow.adtechAdCallbacks[adConfig.adServerVars.uid] || [];
  targetWindow.adtechAdCallbacks[adConfig.adServerVars.uid].push(
      targetWindow.adtechCallbackInstances[instanceIndex]);
})(adtechAdConfig);
